# autonomous.contact

Bringing the BBS back.

## TODO

These are in no particular order. Pull requests updating this section welcome for
feature discussions.

- [ ] should everything be an event in a room?
- [X] sign up
- [X] check for logged in user session
- [X] log in
- [X] refactor login/sessions/totp
- [X] chat rooms
	- [X] chat messages
	- [ ] chat message processing
		- [ ] auto-link urls
			- [ ] use this regex?: `(?:(?<protocol>[a-zA-Z]+):\/\/)?(?:(?<auth>(?<username>\S.+)\:(?<password>.+))\@)?(?<host>(?<hostname>[-a-zA-Z0-9\.]{2,256}\.(?<tld>[-a-zA-Z0-9]{2,256}))(?:\:(?<port>[0-9]{1,6}))?)\b(?<path>[-a-zA-Z0-9@:%_{}\[\]<>\(\)\+.~#&//=]*)(?:\?(?<query>[a-zA-Z0-9!$%&<>()*+,-\.\/\:\;\=\?\@_~]+))?(?:#(?<hash>[a-zA-Z0-9!$&'()*+,-\.\/\:\;\=\?\@_~]+))?`
		- [ ] preview cards for links
		- [ ] embedded video for
			- [ ] youtube
			- [ ] vimeo
			- [ ] tiktok
		- [ ] embedded audio or audio cards for:
			- [ ] tidal
			- [ ] spotify
			- [ ] youtube (any way to differentiate for yt music?)
		- [ ] punycode urls before url extraction? (see: https://stackoverflow.com/a/26618995)
		- [ ] gif support
			- [ ] start/stop gif control
			- [ ] hide control
		- [ ] inline image support
			- [ ] hide control
	- [ ] try to select immediate sibling messages from the same user and hide mulitple avatars
- [X] user profile page
	- [X] logout button
	- [ ] profile editing
	- [ ] avatar uploads
		- [ ] local upload support (keep it simple for small instances)
		- [ ] S3 support (then self-host with your friends: https://garagehq.deuxfleurs.fr/)
- [ ] admin panel
	- [ ] add invite code generation
		- [ ] AC_REQUIRE_INVITE_CODE: boolean env var/setting
	- [ ] AC_DIRECTORY_SERVERS: |-separated list of directory servers to report to
          these central servers could be distributed directories - your town might run one,
		  your state, your country, or you could publish to a public one that is organized
		  around interests
- [ ] combined "bulletin board" instead of exchange/work?
	- [ ] post-it style notes with tag and keyword filtering?
- [ ] simple wiki for resources
- [ ] simple calendar with public/private event tracking
	- [ ] caldav support
- [X] smart forms
	- [X] use the api for forms so requests will be authenticated
	- [X] support multiple methods
- [ ] media uploads
	- [ ] local upload support (keep it simple for small instances)
	- [ ] S3 support (then self-host with your friends: https://garagehq.deuxfleurs.fr/)

## Getting Started Developing

1) Install Deno

	Run their shell script (note: as yourself, not root)

	```
	curl -fsSL https://deno.land/install.sh | sh
	```

	Or using Nix:

	```
	nix-shell -p deno
	```

2) Clone the repo:

	`git clone https://andyburke.dev/andyburke/autonomous.contact.git`

3) Start the server:

	`deno run task serve`

4) Navigate to http://localhost:8000

5) Edit some code and check it out.
